﻿// ChartingLibHelper.cs by Charles Petzold, June 2009
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Reflection;
using System.Globalization;

namespace ChartingLib
{
    public static class ChartingLibHelper
    {
        static Random rand = new Random();

        public static string GenerateName()
        {
            string str = "";
            int num = rand.Next(3, 11);
            char[] vowels = { 'A', 'E', 'I', 'O', 'U' };
            char[] nouns = { 'B', 'C', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 
                             'M', 'N', 'P', 'R', 'S', 'T', 'V', 'W', 'Z' };
            for (int i = 0; i < num; i++)
            {
                char ch;

                if (i % 2 == 0)
                    ch = nouns[rand.Next(nouns.Length)];
                else
                    ch = vowels[rand.Next(vowels.Length)];

                str += (i == 0) ? ch : Char.ToLower(ch);
            }
            return str;
        }

        public static double GetRoundedMaximum(double maximum, params double[] factors)
        {
            if (maximum <= 0)
                return 0;

            double log = Math.Log10(maximum);
            double characteristic = Math.Floor(log);
            double mantissa = log - Math.Floor(log);
            double multFactor = Math.Pow(10, mantissa);

            if (multFactor == 1)
                multFactor = 1;
            else
            {
                int index;

                for (index = 0; index < factors.Length; index++)
                {
                    if (multFactor < factors[index])
                    {
                        multFactor = factors[index];
                        break;
                    }
                }
                if (index == factors.Length)
                    multFactor = 10;
            }

            return multFactor * Math.Pow(10, characteristic);
        }
    }
}
