﻿// ChildIndexProvider.cs by Charles Petzold, June 2009
using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace ChartingLib
{
    public class ChildIndexProvider : Decorator
    {
        static readonly DependencyPropertyKey IndexKey =
            DependencyProperty.RegisterReadOnly("Index",
                typeof(int),
                typeof(ChildIndexProvider),
                new PropertyMetadata());

        public static readonly DependencyProperty IndexProperty =
            IndexKey.DependencyProperty;

        public ChildIndexProvider()
        {
            LayoutUpdated += OnLayoutUpdated;
        }

        public int Index
        {
            protected set { SetValue(IndexKey, value); }
            get { return (int)GetValue(IndexProperty); }
        }

        void OnLayoutUpdated(object sender, EventArgs args)
        {
            ContentPresenter contPres = TemplatedParent as ContentPresenter;

            if (contPres != null)
            {
                Panel pnl = VisualTreeHelper.GetParent(contPres) as Panel;

                if (pnl != null)
                    Index = pnl.Children.IndexOf(contPres);
            }
        }
    }
}
