﻿// Doodad.cs by Charles Petzold, June 2009
using System;
using System.ComponentModel;

namespace ChartingLib
{
    public class Doodad : INotifyPropertyChanged
    {
        string modelName;
        double baseCost, addlCost, extraCost;
        int productType;

        public event PropertyChangedEventHandler PropertyChanged;

        public string ModelName
        {
            set
            {
                if (value != modelName)
                {
                    modelName = value;
                    OnPropertyChanged("ModelName");
                }
            }
            get
            {
                return modelName;
            }
        }

        public int ProductType
        {
            set
            {
                if (value != productType)
                {
                    productType = value;
                    OnPropertyChanged("ProductType");
                }
            }
            get
            {
                return productType;
            }
        }

        public double BaseCost
        {
            set
            {
                if (value != baseCost)
                {
                    baseCost = value;
                    OnPropertyChanged("BaseCost");
                }
            }
            get
            {
                return baseCost;
            }
        }

        public double AdditionalCost
        {
            set
            {
                if (value != addlCost)
                {
                    addlCost = value;
                    OnPropertyChanged("AdditionalCost");
                }
            }
            get
            {
                return addlCost;
            }
        }

        public double ExtraCost
        {
            set
            {
                if (value != extraCost)
                {
                    extraCost = value;
                    OnPropertyChanged("ExtraCost");
                }
            }
            get
            {
                return extraCost;
            }
        }

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
