﻿// DoodadPresenter.cs by Charles Petzold, June 2009
using System;
using System.Windows.Threading;

namespace ChartingLib
{
    public class DoodadPresenter
    {
        Random rand = new Random();

        public DoodadPresenter()
        {
            DoodadCollection = new DoodadCollection();

            for (int i = 0; i < 20; i++)
            {
                Doodad doodad = new Doodad();
                doodad.ModelName = ChartingLibHelper.GenerateName();
                doodad.ProductType = rand.Next(4);
                doodad.BaseCost = 50 + 100 * rand.NextDouble();
                doodad.AdditionalCost = 50 * rand.NextDouble();
                doodad.ExtraCost = 25 * rand.NextDouble();
                DoodadCollection.Add(doodad);
            }

            DispatcherTimer tmr = new DispatcherTimer();
            tmr.Interval = TimeSpan.FromSeconds(1);
            tmr.Tick += OnTimerTick;
            tmr.Start();
        }

        public DoodadCollection DoodadCollection { get; set; }

        void OnTimerTick(object sender, EventArgs e)
        {
            int whatToChange = rand.Next(3);
            int index = rand.Next(DoodadCollection.Count);
            Doodad doodad = DoodadCollection[index];
            double increase = 0.95 + 0.1 * rand.NextDouble();

            switch (whatToChange)
            {
                case 0: doodad.BaseCost *= increase; break;
                case 1: doodad.AdditionalCost *= increase; break;
                case 2: doodad.ExtraCost *= increase; break;
            }
        }
    }
}
