﻿// ProductSales.cs by Charles Petzold, June 2009
using System;
using System.ComponentModel;

namespace ChartingLib
{
    public class Product : INotifyPropertyChanged
    {
        string name;
        double sales, percentage, accumulated;

        public event PropertyChangedEventHandler PropertyChanged;

        public Product()
        {
        }

        public Product(string name, double sales)
        {
            Name = name;
            Sales = sales;
        }

        public string Name
        {
            set
            {
                if (value != name)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
            get 
            { 
                return name; 
            }
        }

        public double Sales
        {
            set
            {
                if (value != sales)
                {
                    sales = value;
                    OnPropertyChanged("Sales");
                }
            }
            get
            {
                return sales;
            }
        }

        public double Percentage
        {
            set
            {
                if (value != percentage)
                {
                    percentage = value;
                    OnPropertyChanged("Percentage");
                }
            }
            get
            {
                return percentage;
            }
        }

        public double Accumulated
        {
            set
            {
                if (value != accumulated)
                {
                    accumulated = value;
                    OnPropertyChanged("Accumulated");
                }
            }
            get
            {
                return accumulated;
            }
        }

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
