﻿// ProductLineup.cs by Charles Petzold, June 2009
using System;
using System.Collections.ObjectModel;
using System.Windows.Threading;

namespace ChartingLib
{
    public class ProductLineup: ObservableCollection<Product>
    {
        const double BaseSales = 1000000;
        Random rand = new Random();

        public ProductLineup()
        {
            Add(new Product("Widget", BaseSales * rand.NextDouble()));
            Add(new Product("Gizmo", BaseSales * rand.NextDouble()));
            Add(new Product("Doodad", BaseSales * rand.NextDouble()));
            Add(new Product("Thingy", BaseSales * rand.NextDouble()));
            Add(new Product("Geegaw", BaseSales * rand.NextDouble()));
            Add(new Product("Whatchmacallit", BaseSales * rand.NextDouble()));
            Add(new Product("Hoozit", BaseSales * rand.NextDouble()));

            DispatcherTimer tmr = new DispatcherTimer();
            tmr.Tick += new EventHandler(OnTimerTick);
            tmr.Interval = TimeSpan.FromSeconds(1);
            tmr.Start();            
        }

        void OnTimerTick(object sender, EventArgs args)
        {
            double total = 0;

            foreach (Product product in Items)
            {
                product.Sales *= 0.95 + 0.1 * rand.NextDouble();
                total += product.Sales;
            }

            double accum = 0;

            foreach (Product product in Items)
            {
                product.Percentage = product.Sales / total;
                product.Accumulated = accum;
                accum += product.Percentage;
            }
        }
    }
}
